Foreman - Bug #12936

Hostgroup environment isn't inherited by Host via model API
12/24/2015 03:59 AM - Daniel Lobato Garcia

Status: Closed
Priority: Normal
Assignee: Ondrej Prazak
Category: Host creation
Target version: 1.11.1
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1367136 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3243
Description
Problem:

Since [[hostgroup_inherited_attributes](https:/github.com/theforeman/foreman/blob/develop/app/models/host/managed.rb#L.577)]
uses association IDs instead of AR objects, creating hosts like

hg.environment = Environment.first
sample_host = Host.new(:name => 'hostname', :hostgroup => hg).environment
sample_host.environment == nil #=> true

will not work.

The method to inherit these attributes relies on string attributes so Host must be created using 'hostgroup_id' or 'hostgroup_name' to
inherit hostgroup attributes, like:

sample_host = Host.new(:name => 'hostname', 'hostgroup_id' => hg.id)
Solution:

Make apply_inherited_attributes capable of inheriting regular AR relations, and not just attributes when passed as strings. That's why
inheritance only works from the Ul.

Associated revisions

Revision d7110d54 - 03/02/2016 04:45 AM - Ondfej Prazak
Fixes #12936 - Host inherits attributes when hostgroup is AR object

Revision 647b971f - 04/18/2016 01:45 PM - Ondiej Prazak
Fixes #12936 - Host inherits attributes when hostgroup is AR object

(cherry picked from commit d7110d54ad51a85eadde8283606e88cf01de8b19)

History

#1 - 12/24/2015 04:01 AM - Dominic Cleal
- Subject changed from Hostgroup environment isn't inherited by Host to Hostgroup environment isn't inherited by Host via model API

- Category set to Host creation

#2 - 02/26/2016 09:46 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Ondrej PraZzak

- Pull request https://github.com/theforeman/foreman/pull/3243 added

#3 - 03/02/2016 05:01 AM - Ondfej Prazak
https://github.com/theforeman/foreman/blob/develop/app/models/host/managed.rb#L577

- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset d7110d54ad51 2 01 19.

#4 - 03/02/2016 06:04 AM - Dominic Cleal

- translation missing: en.field_release set to 141

#5 - 08/15/2016 12:54 PM - Shimon Shtein
- Bugzilla link set to 1367136
